﻿/*Copyright 2024 Wojciech Krzysztof Fiałkiewicz

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

namespace Fractals_Visualizer
{
    public class ComplexPythagorasNumber : ComplexNumber
    {
        public static ComplexNumber ConvertToComplexNumber(ComplexPythagorasNumber cpn, bool A = true)
        {
            ComplexNumber cn = new ComplexNumber();

            //cn.a = (cpn.a + 0.2 * Math.Cos(cpn.b)) * Math.Cos(cpn.a);
            //cn.b = (cpn.b + 0.2 * Math.Cos(cpn.a)) * Math.Cos(cpn.b);

            //cn.a = cpn.a;
            //cn.b = (Math.Sqrt(cpn.a * cpn.a + cpn.b * cpn.b) - cpn.a) / (cpn.a - Math.Sqrt(cpn.a * cpn.a + cpn.b * cpn.b));

            //cn.a = cpn.a + 0.15 * Math.Cos(cpn.a);
            //cn.b = cpn.b + 0.15 * Math.Cos(cpn.b);

            if (A)
            {
                cn.a = cpn.a + cpn.a * 0.1;
                cn.b = cpn.b;
            }
            else
            {
                cn.a = cpn.a;
                cn.b = cpn.b + cpn.b * 0.1;
            }


            return cn;
        }

        public ComplexPythagorasNumber()
        {

        }

        public ComplexPythagorasNumber(ComplexNumber cn)
        {
            a = cn.a;
            b = cn.b;
        }

        public static ComplexPythagorasNumber operator+(ComplexPythagorasNumber a, ComplexPythagorasNumber b)
        {
            return new ComplexPythagorasNumber(ConvertToComplexNumber(a) + ConvertToComplexNumber(b));
        }

        public static ComplexPythagorasNumber operator -(ComplexPythagorasNumber a, ComplexPythagorasNumber b)
        {
            return new ComplexPythagorasNumber(ConvertToComplexNumber(a) - ConvertToComplexNumber(b));
        }

        public static ComplexPythagorasNumber operator *(ComplexPythagorasNumber a, ComplexPythagorasNumber b)
        {
            return new ComplexPythagorasNumber(ConvertToComplexNumber(a) * ConvertToComplexNumber(b));
        }

        public static ComplexPythagorasNumber operator /(ComplexPythagorasNumber a, ComplexPythagorasNumber b)
        {
            return new ComplexPythagorasNumber(ConvertToComplexNumber(a) / ConvertToComplexNumber(b));
        }
    }
}
