﻿/*Copyright 2024 Wojciech Krzysztof Fiałkiewicz

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace Fractals_Visualizer
{
    public partial class Deep : Form
    {
        protected int m_DeepValue = 30;

        public int DeepValue
        { 
            get
            {
                return m_DeepValue;
            }
            set
            {
                m_DeepValue = value;
                textBoxDeepValue.Text = m_DeepValue.ToString();
            }
        } 

        public Deep()
        {
            InitializeComponent();
        }

        private void textBoxDeepValue_Validating(object sender, CancelEventArgs e)
        {
            int val;

            if (int.TryParse(textBoxDeepValue.Text, out val))
            {
                m_DeepValue = val;
            }
            else
            {
                e.Cancel = true;
            }
        }

        private void buttonSet_Click(object sender, EventArgs e)
        {
            base.DialogResult = DialogResult.OK;
            base.Close();
        }
    }
}
